Halide 22.0.0 Halide compiler and libraries

Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::CastOp< A > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2 >
HALIDE_ALWAYS_INLINE bool | match (const CastOp< A2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const

## Public Attributes
Type | t
A | a

## Static Public Attributes
static constexpr uint32_t | binds = bindings<A>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Cast
static constexpr IRNodeType | max_node_type = IRNodeType::Cast
static constexpr bool | canonical = A::canonical
static constexpr bool | foldable = false

## Detailed Description

template<typename A>
struct Halide::Internal::IRMatcher::CastOp< A >

Definition at line 2096 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/2]

template<typename A >
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::CastOp< A >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 2108 of file IRMatch.h.

References Halide::Internal::Cast::_node_type, Halide::Internal::IRMatcher::CastOp< A >::a, Halide::Expr::get(), Halide::Internal::IRMatcher::CastOp< A >::t, and Halide::Internal::Cast::value.

## ◆ match() [2/2]

template<typename A >
template<uint32_t bound, typename A2 >

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::CastOp< A >::match | ( | const CastOp< A2 > & | op,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 2117 of file IRMatch.h.

References Halide::Internal::IRMatcher::CastOp< A >::a, Halide::Internal::IRMatcher::CastOp< A >::t, and Halide::Internal::IRMatcher::unwrap().

## ◆ make()

template<typename A >

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::CastOp< A >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 2122 of file IRMatch.h.

References Halide::Internal::IRMatcher::CastOp< A >::a, Halide::Internal::IRMatcher::cast(), and Halide::Internal::IRMatcher::CastOp< A >::t.

## Member Data Documentation

## ◆ t

template<typename A >

Type Halide::Internal::IRMatcher::CastOp< A >::t

Definition at line 2098 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::CastOp< A >::make(), Halide::Internal::IRMatcher::CastOp< A >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ a

template<typename A >

A Halide::Internal::IRMatcher::CastOp< A >::a

Definition at line 2099 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::CastOp< A >::make(), Halide::Internal::IRMatcher::CastOp< A >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ binds

template<typename A >

constexpr uint32_t Halide::Internal::IRMatcher::CastOp< A >::binds = bindings<A>::mask
| static constexpr

Definition at line 2101 of file IRMatch.h.

## ◆ min_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::CastOp< A >::min_node_type = IRNodeType::Cast
| static constexpr

Definition at line 2103 of file IRMatch.h.

## ◆ max_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::CastOp< A >::max_node_type = IRNodeType::Cast
| static constexpr

Definition at line 2104 of file IRMatch.h.

## ◆ canonical

template<typename A >

constexpr bool Halide::Internal::IRMatcher::CastOp< A >::canonical = A::canonical
| static constexpr

Definition at line 2105 of file IRMatch.h.

## ◆ foldable

template<typename A >

constexpr bool Halide::Internal::IRMatcher::CastOp< A >::foldable = false
| static constexpr

Definition at line 2126 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h